//+------------------------------------------------------------------+
//|                                                     Roulette.mq5 |
//|                                      Copyright 2011, JQS aka Joo |
//|                              https://login.mql5.com/ru/users/joo |
//+------------------------------------------------------------------+
#property copyright "Copyright 2011, JQS aka Joo"
#property link      "https://login.mql5.com/ru/users/joo"
#property version   "1.00"
#property script_show_inputs
//--- input parameters
input int RollCount=10000000;
input int ArrSize  =10240;
class CRoulette
  {
   int               PopSize;
   double            select[];
   double            sum;
public:
                     CRoulette(void){}
                    ~CRoulette(void){}
   void              Reset(double &NewArray[])
     {
      PopSize=ArraySize(NewArray);
      ArrayResize(select,PopSize);
      sum=0;
      double zero=NewArray[PopSize-1]-1.1;
      for(int i=0; i<PopSize; i++)
        {
         select[i]=sum+=NewArray[i]-zero;
        }
     }
   int QuickRoulette(int r)
     {
      double p=RNDfromCI(0,sum);
      int l=0,m=(l+(--r))>>1;
      while(l<r)
        {
         if(select[m]>=p) r=m;
         else l=m+1;
         m=(l+r)>>1;
        }
      return m;
     }
   int Roulette(int ps)
     {
      //  ""
      double p=RNDfromCI(0,sum);
      // ,     ""
      for(int u=0;u<ps;u++) if(select[u]>=p) return(u);
      return -1;
     }
   //      .
   double RNDfromCI(double min,double max)
     {return(min+((max-min)*MathRand()/32767.0));}
  };
//+------------------------------------------------------------------+
//
void OnStart()
  {
   MathSrand((int)GetTickCount());//  

                                  
   double array[];
   ArrayResize(array,ArrSize);
   ArraySetAsSeries(array,true);
   for (int i=0; i<ArrSize; i++) array[i]=(rand()+rand())/23.23431257;
   ArraySort(array);

   CRoulette  R;   
   R.Reset(array);
//         
   int h[]; ArrayResize(h,ArrSize);  ArrayInitialize(h,0);

//   
   int time_start=(int)GetTickCount();

//   
   for(int i=0;i<RollCount;i++) { h[R.Roulette(ArrSize)]++;  }

   Print((int)GetTickCount()-time_start,"  -   Roulette");
   for(int i=5;i>-1;i--)
     {
      Print("h",i," = ",h[i],";  ",h[i]*100.0/RollCount);
     }
     
   ArrayInitialize(h,0);  
//   
   time_start=(int)GetTickCount();

//   
   for(int i=0;i<RollCount;i++) { h[R.QuickRoulette(ArrSize)]++;  }

   Print((int)GetTickCount()-time_start,"  -   QuickRoulette");
   for(int i=5;i>-1;i--)
     {
      Print("h",i," = ",h[i],";  ",h[i]*100.0/RollCount);
     }
   Print("----------------");
  }
//
